module TalltyForm
  class FieldOption < DuckRecord::MetaRecord
    embeds_many :fields, class_name: "::TalltyForm::FieldOption::Field"
    accepts_nested_attributes_for :fields

    class Field < MetaRecord
      embeds_one :model, class_name: "::TalltyForm::FieldOption::Model"
      accepts_nested_attributes_for :model

      attribute :key, :string
      attribute :name, :string
      attribute :map_key, :string
      attribute :layout, :json

      attr_readonly :name
      attr_readonly :key

      validates :name, presence: true
      validates :key, presence: true
    end

    class Model < MetaRecord
      attribute :attr_type, :string
      enum attr_type: {string: 0, integer: 1, boolean: 2, datetime: 3, date: 4, time: 5, json: 6, text: 7, number: 8, array: 9, object: 10 },
        _prefix: :access
      validates :attr_type,
        inclusion: {in: self.attr_types.keys.map(&:to_sym)}

      def attr_type
        self[:attr_type]&.to_sym
      end
    end
  end
end
